<%@page contentType="text/javascript" %>
<%@ taglib prefix="formfactory" uri="http://www.jahia.org/formfactory/functions" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<jcr:propertyInitializers var="countries" nodeType="fcnt:countryListDefinition" name="country"/>

(function(){
    var addressBlock = function($log, ffTemplateResolver, _) {
        var directive = {
            restrict   : 'E',
            require    : ['^ffController'],
            templateUrl: function(el, attrs) {
                return ffTemplateResolver.resolveTemplatePath('${formfactory:addFormFactoryModulePath('/form-factory-definitions/address-block', renderContext)}', attrs.viewType);
            },
            link       : postLinkFunc
        };
        return directive;
        function postLinkFunc(scope, el, attr, ctrl) {
            var formController = ctrl[0];
            scope.input.value = {
                rendererName:'address'
            };
            scope.countries = [
                <c:forEach items="${countries}" var="country" varStatus="s">
                {country:{key:'${country.value.string}',name:'${functions:escapeJavaScript(country.displayName)}'}}<c:if test="${not s.last}">,</c:if>
                </c:forEach>
            ];

            //do this only if we are in live
            if (formController.isLiveMode()) {
                scope.$watchCollection(function (scope) {
                    return scope.input.value;
                }, function (newValue, oldValue, scope) {
                    if (!_.isUndefined(newValue) && !_.isUndefined(oldValue) && !_.isEqual(newValue, oldValue)) {
                        scope.form[scope.input.name].$setDirty();
                        scope.form[scope.input.name].$setTouched();
                        scope.ffValidate();
                    }
                });
                scope.ffValidate();
            }
            
            scope.isFieldValid = function (fieldName) {
                var val = scope.input.value[fieldName];
                return !(_.isUndefined(val) || _.isNull(val) || _.isEmpty(val));
            }
        }
    };
    angular
            .module('formFactory')
            .directive('ffAddress', ['$log', 'ffTemplateResolver', '_', addressBlock]);
})();