<%@ page contentType="text/javascript" %>

        /**
         * Validates that the value is between the specified range or meets the required limit .
         * Receives the rule definition and its scope.
         * scope.$parent will contain the form to enable watch and access to other fields in the same step
         * ctrls will be an array of controllers, first the ffFormController and then the ngModel of the associated input
         *
         * @param {object} rule current rule definition
         * @param {object} scope current input scope
         * @param {object} el current html element
         * @param {array} attr attributes of the html element
         * @param {array} ctrls ctrls[0] = FFFormController ctrls[1]=ngModel
         */

        ff.validationRules.address = function (rule, scope, el, attr, ctrls) {
            var inputModelController = ctrls[1];
            scope.$watch(function () {
                return scope.form[scope.input.name].$valid;
            }, function () {
                inputModelController.$validate();
            });
            return  function (newValue, oldValue) {
                var validity = true;
                if (_.isUndefined(newValue.address1) || _.isNull(newValue.address1) || _.isEmpty(newValue.address1)) {
                    validity = false;
                }
                if (_.isUndefined(newValue.zipcode) || _.isNull(newValue.zipcode) || _.isEmpty(newValue.zipcode)) {
                    validity = false;
                }
                if (_.isUndefined(newValue.city) || _.isNull(newValue.city) || _.isEmpty(newValue.city)) {
                    validity = false;
                }
                if (_.isUndefined(newValue.country) || _.isNull(newValue.country) || _.isEmpty(newValue.country)) {
                    validity = false;
                }
                return validity;
            };
        };