<%@ page contentType="text/javascript" %>
<%@ taglib prefix="formfactory" uri="http://www.jahia.org/formfactory/functions" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<jcr:propertyInitializers var="countries" nodeType="fcnt:countryListDefinition" name="country"/>
angular
    .module('formFactory')
    .directive('ffSelectCountry', ['$log', 'ffTemplateResolver', function ($log, ffTemplateResolver) {
        var directive = {
            restrict: 'E',
            require: ['^ffController'],
            templateUrl: function(el, attrs) {
                return ffTemplateResolver.resolveTemplatePath('${formfactory:addFormFactoryModulePath('/form-factory-definitions/select-country', renderContext)}', attrs.viewType);
            },
            link: linkFunc
        };

        return directive;

        function linkFunc(scope, el, attr, ctrl) {
            scope.$watch(function () {
                return !_.isUndefined(scope.input) && scope.input !== null && !_.isUndefined(scope.input.topSelections) ? scope.input.topSelections.length : null;
            }, function (listAvailable) {
                if (listAvailable !== null) {
                    sortList();
                }
            });

            var countryList = [
                <c:forEach items="${countries}" var="country" varStatus="s">
                {
                    country:
                    {
                        key: '${country.value.string}',
                        name: '${functions:escapeJavaScript(country.displayName)}'
                    },
                    rendererName: 'country'
                }<c:if test="${not s.last}">, </c:if>
                </c:forEach>
            ];

            sortList();

            //Sort countries by putting topSelections on top of the list
            function sortList() {
                countryList.sort();//Restore alphabetic order
                var topItems = [];
                var otherItems = [];
                if (scope.input.topSelections.length <= 0) {
                    scope.countries = countryList;
                    return;
                }

                for (var k in scope.input.topSelections) {
                    for (var i in countryList) {
                        if (countryList[i].country.key === scope.input.topSelections[k]) {
                            topItems.push(angular.copy(countryList[i]));
                        }
                    }
                }

                for (var i in countryList) {
                    if (notInTop(countryList[i].country.key)) {
                        otherItems.push(angular.copy(countryList[i]));
                    }
                }

                scope.countries = topItems.concat(otherItems);

                function notInTop(key) {
                    for (var i in scope.input.topSelections) {
                        if (key === scope.input.topSelections[i]) {
                            return false;
                        }
                    }
                    return true;
                }
            }
        }
    }]);