<%@ page contentType="text/javascript" %>
<%@ taglib prefix="formfactory" uri="http://www.jahia.org/formfactory/functions" %>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>

angular
    .module('formFactory')
    .directive('ffFileUpload', ['$log', 'ffTemplateResolver', function ($log, ffTemplateResolver) {
        var directive = {
            restrict: 'E',
            require: ['^ffController'],
            templateUrl: function(el, attrs) {
                return ffTemplateResolver.resolveTemplatePath('${formfactory:addFormFactoryModulePath('/form-factory-definitions/file-upload', renderContext)}', attrs.viewType);
            },
        };

        return directive;
    }])
    .directive('ffFileInput', ['$log', function ($log) {
        var directive = {
            restrict: 'A',
            require: ['^ffController', '^ngModel'],
            link: linkFunction
        };

        return directive;

        function linkFunction(scope, el, attr, ctrl) {
            var modelGetter = ctrl[1];
            var modelSetter = modelGetter.$setViewValue;

            // Callback called whenever a change happens in the input
            var onChange = function (event) {
                modelSetter(null, 'change');
                modelSetter(event.target.files, 'change');
            };

            el.bind('change', onChange);
        }
    }]).directive('ffFileInputDisplay', ['$log', function ($log) {
        var directive = {
            restrict: 'A',
            require: ['^ffController', '^ngModel'],
            link: linkFunction
        };

        return directive;

        function linkFunction(scope, el, attr, ctrl) {
            if (scope.input.value != null && !(typeof scope.input.value === "string")) {
                if (el.hasClass('fileinput-new')) {
                    el.hide();
                } else if (el.hasClass('fileinput-exists')) {
                    el.show();
                } else if (el.hasClass('fileinput-filename')) {
                    el.show();
                    el.html(scope.input.value[0].name);
                }
            }
        }
    }]);
