<%@ page contentType="text/javascript" %>
/**
 * Check if specified value(s) is contained in the specified multiple select input
 * Each rule will received, the rule definition, its scope.
 * scope.form will contain the form to enable watch and access to other fields in the same step
 * ctrls will be an array of controllers, first the ffFormController and then the ngModel of the associated input.
 *
 * @param {object} rule current rule definition
 * @param {object} scope current input scope
 * @param {object} el current html element
 * @param {array} attr attributes of the html element
 * @param {array} ctrls ctrls[0] = FFFormController ctrls[1]=ngModel
 */
ff.logicRules.ifCountryIs = function (rule, scope, el, attr, ctrls) {
    'use strict';
    var requiredValue = rule.requiredValue;
    return function (scope, fieldValue) {
        if (_.isUndefined(fieldValue) || _.isEmpty(fieldValue)) {
            return false;
        }
        return _.contains(requiredValue, fieldValue.country.name);
    }
};