<%@ page contentType="text/javascript" %>
/**
 * Validates that there is at least one key per row selected.
 * Receives the rule definition and its scope.
 * scope.$parent will contain the form to enable watch and access to other fields in the same step
 * ctrls will be an array of controllers, first the ffFormController and then the ngModel of the associated input
 *
 * @param {object} rule current rule definition
 * @param {object} scope current input scope
 * @param {object} el current html element
 * @param {array} attr attributes of the html element
 * @param {array} ctrls ctrls[0] = FFFormController ctrls[1]=ngModel
 */
ff.validationRules.matrixRequiredRows = function(rule, scope, el, attr, ctrls) {
    'use strict';

    var requiredNumOfRows = parseInt(attr.numberOfRows);

    return function (modelValue, viewValue) {
        var selectedRows = 0;
        _.each(viewValue, function(arrayOfValues) {
            if (!_.isEmpty(arrayOfValues)) {
                selectedRows++;
            }
        });
        //Do in order -1 to void the rendererName property that is in the values array.
        return requiredNumOfRows === selectedRows-1;
    };
};