<%@ page contentType="text/javascript" %>
/**
 * Applies the supplied regex to the entered value.
 * Receives the rule definition and its scope.
 * scope.$parent will contain the form to enable watch and access to other fields in the same step
 * ctrls will be an array of controllers, first the ffFormController and then the ngModel of the associated input
 *
 * @param {object} rule current rule definition
 * @param {object} scope current input scope
 * @param {object} el current html element
 * @param {array} attr attributes of the html element
 * @param {array} ctrls ctrls[0] = FFFormController ctrls[1]=ngModel
 */

ff.validationRules.regex = function (rule, scope, el, attr, ctrls) {
    var model = ctrls[1];
    var pattern = rule.regexfield;
    var regexp;

    if(angular.isString(pattern) && pattern.length > 0){
        regexp = new RegExp(pattern);
    }

    if (regexp && !regexp.test) {
        throw minErr('ngPattern')('noregexp',
                'Expected {0} to be a RegExp but was {1}. Element: {2}', rule.pattern,
                regexp, startingTag(el));
    }

    return function(modelValue, viewValue){
        if(_.isUndefined(viewValue) || _.isEmpty(viewValue)){
            return true;
        }
        return angular.isUndefined(regexp) || regexp.test(viewValue);
    }

};