<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="fc" uri="http://www.jahia.org/formfactory/functions" %>

<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="flowRequestContext" type="org.springframework.webflow.execution.RequestContext"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>

<template:addResources type="css" resources="lib/packages/datatables/media/css/dataTables.bootstrap.css"/>
<template:addResources type="css" resources="lib/font-awesome/css/font-awesome.min.css"/>
<template:addResources type="css" resources="builder.css"/>
<template:addResources type="javascript" resources="lib/backbone.js"/>
<template:addResources type="javascript" resources="lib/backbone.paginator.min.js"/>
<template:addResources type="javascript" resources="main-results.js"/>
<template:addResources type="javascript" resources="collections/forms.js"/>
<template:addResources type="javascript" resources="fcResultsUtils.js"/>
<template:addResources type="javascript" resources="workInProgress.js"/>

<jcr:node path="/sites/${renderContext.site.name}/formFactory/results" var="fcResultsNode"/>
<c:choose>
    <c:when test="${empty param}">
        <c:remove var="formUuid" scope="session"/>
        <c:remove var="view" scope="session"/>
        <c:remove var="actionUUID" scope="session"/>
        <c:remove var="actionview" scope="session"/>
    </c:when>
    <c:otherwise>
        <c:if test="${not empty param.view}">
            <c:set var="view" value="${param.view}" scope="session"/>
        </c:if>
        <c:if test="${not empty param.formUuid}">
            <c:set var="formUuid" value="${param.formUuid}" scope="session"/>
        </c:if>
        <c:if test="${not empty param.actionUUID}">
            <c:set var="actionUUID" value="${param.actionUUID}" scope="session"/>
        </c:if>
        <c:if test="${not empty param.actionview}">
            <c:set var="actionview" value="${param.actionview}" scope="session"/>
        </c:if>
    </c:otherwise>
</c:choose>


<c:set var="resultToDisplay" value="${(!empty formUuid) and (!empty view)}"/>
<c:if test="${! empty formUuid}">
    <jcr:node uuid="${formUuid}" var="submissionsNode"/>
</c:if>
<c:if test="${! empty actionUUID}">
    <jcr:node uuid="${actionUUID}" var="actionNode"/>
</c:if>

<c:url var="currentPageURL" value="${url.baseEdit}${renderContext.mainResource.path}"/>

<fmt:message key="ff.label.name" var="nameHeader"/>
<fmt:message key="ff.label.date" var="dateHeader"/>
<fmt:message key="fcnt_result.submissions" var="subCountHeader"/>
<fmt:message key="fcnt_result.display" var="displayHeader"/>

<template:addResources type="inlinejavascript">
    <script>
        _.templateSettings = {
            interpolate: /\<\@\=(.+?)\@\>/gim,
            evaluate: /\<\@(.+?)\@\>/gim,
            escape: /\<\@\-(.+?)\@\>/gim
        };
        var actionsViews = {};
        var actionsProviders = [];
        var API_URL_BASE = '${url.context}/modules/formfactory/results';
        var formModel;
        var CONTEXT = "${url.context}";
        var locale = "${currentResource.locale}";
        var UIlocale = "${renderContext.UILocale.language}";
        var resultsFetched = false;
        var selectedResult = "${formUuid}";
        var selectedView = "${view}";
        var selectFormTable;
        var formsView;
        var urlCurrentModule = "${functions:escapeJavaScript(url.currentModule)}";
        var _resultsRenderer = ${fc:renderer(renderContext)};
        //Creating Forms collection View
        formsView = new FormsResultsView({collection: new FormsCollection()});
        formsView.siteUrl = "${url.context}${url.baseEdit}${renderContext.site.path}";
        formsView.nameHeader = "${fn:escapeXml(nameHeader)}";
        formsView.dateHeader = "${fn:escapeXml(dateHeader)}";
        formsView.subCountHeader = "${fn:escapeXml(subCountHeader)}";
        formsView.displayHeader = "${fn:escapeXml(displayHeader)}";
        formsView.dataTableNoResult = "<fmt:message key="fcnt.dataTableNoResult"/>";
        formsView.buttonText = "<fmt:message key="fcnt_result.label.displayForm"/>";
        formsView.collection.resourceId = "${fcResultsNode.identifier}";
        formsView.collection.urlBase = API_URL_BASE + "/" + locale + "/" + formsView.collection.resourceId + "/";
        formsView.resultToDisplay =${resultToDisplay};
        formsView.searchLabel = "<fmt:message key="ff.label.search"/>";
        formsView.resultsFromLabel = "<fmt:message key="fcnt_result.resultsFrom"/>";
        formsView.resultsToLabel = "<fmt:message key="fcnt_result.resultsTo"/>";

        <!-- In Display result mode, fetch forms for metadata but no display -->
        <c:if test="${resultToDisplay}">
        formsView.collection.fetch({
            async: false,
            success: function () {
                resultsFetched = true;
                formModel = formsView.collection.find(function (model) {
                    return model.get("resultFormId") == "${formUuid}"
                });
            }
        });
        </c:if>

        $(document).ready(function () {

            fillActionViews("${fcResultsNode.identifier}", API_URL_BASE, UIlocale);

            var url = API_URL_BASE + "/" + locale + "/" + "${fcResultsNode.identifier}/actions/providers";
            //Getting actions
            $.ajax({
                type: "GET",
                async: false,
                url: url,
                success: function (result) {
                    actionsProviders = result.data;
                }
            });

            if (!resultsFetched) {
                formsView.collection.fetch();
            }
            else {
                fillviewSelect("${formUuid}", "${view}", ${!empty formUuid});
            }
        });
    </script>
</template:addResources>

<c:choose>
    <c:when test="${resultToDisplay}">
        <div class="bg-info">
        <div class="builder-page-header">
            <h2><fmt:message key="fcnt_results.title.formResults"/>: ${submissionsNode.parent.properties["jcr:title"].string}</h2>
        </div>
        </div>

        <div id="templateDisplay" class="row">
            <div class="col-sm-12">
                <template:module node="${actionNode}" view="${actionview}"/>
                <template:area path="${submissionsNode.path}" areaType="fcnt:submissions" view="${view}"
                               editable="false"/>
            </div>
        </div>
    </c:when>
    <c:otherwise>
        <div class="bg-info">
            <div class="builder-page-header">
                <h2><fmt:message key="fcnt_results.title.formResults"/></h2>
            </div>
        </div>
            <table class="table table-striped table-bordered" id="select_form" width="100%" cellspacing="0">
            </table>
    </c:otherwise>
</c:choose>
