<%@ page contentType="text/javascript" %>
<%@ taglib prefix="formfactory" uri="http://www.jahia.org/formfactory/functions" %>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>

angular
    .module('formFactory')
    .directive('ffSwitchInput', ['$log', 'ffTemplateResolver', '$compile', 'ffDataFactory', 'i18nService', function ($log, ffTemplateResolver, $compile, ffDataFactory, i18n) {
        var directive = {
            restrict: 'E',
            require: ['^ffController'],
            templateUrl: function(el, attrs) {
                return ffTemplateResolver.resolveTemplatePath('${formfactory:addFormFactoryModulePath('/form-factory-definitions/switch-input', renderContext)}', attrs.viewType);
            },
            link: linkFunction
        };

        return directive;


        function linkFunction(scope, el, attr, ctrl) {
            //Set field to dirty once it changes its value
            var unregisterDirtySetter = scope.$watch(function() {
                return scope.input.value;
            }, function(n, o) {
                if (n !== null && o !== null && n !== o) {
                    if (scope.input.name !== undefined && scope.form !== undefined && scope.form[scope.input.name] !== undefined) {
                        scope.form[scope.input.name].$setDirty();
                    }
                    unregisterDirtySetter();
                }
            });

            scope.input.displayText = toBool(scope.input.displayText);
            scope.input.value = toBool(scope.input.value);
            scope.green = i18n.message('fcnt_switchDefinition.label.green');
            scope.red = i18n.message('fcnt_switchDefinition.label.red');
            scope.blue = i18n.message('fcnt_switchDefinition.label.blue');

            scope.$watch(function() {
                return scope.input.color;
            }, function() {
                ffDataFactory.customRequest({
                    url: ffTemplateResolver.resolveTemplatePath('${formfactory:addFormFactoryModulePath('/form-factory-definitions/switch-input', renderContext)}', attr.viewType),
                    method: 'GET'
                }).then(function (response) {
                    el.html(response);
                    $compile(el.contents())(scope);
                });
            });

            function toBool(value) {
                if (typeof value === 'boolean') {
                    return value;
                }
                else {
                    return value === 'true';
                }
            }
        }
    }]);