(function () {
    'use strict';
    angular.module('formFactory', ['ui.router', 'formFactory.dataFactory', 'datatables', 'datatables.bootstrap', 'i18n',
        'ui.bootstrap', 'ui.bootstrap.tooltip', 'formFactory.commonUseFactory', 'ngResource', 'checklist-model',
        'uiSwitch', 'formFactory.templateResolver', 'toaster', 'ngAnimate'], function ($uibTooltipProvider) {
        $uibTooltipProvider.options({
            placement: 'bottom',
            popupDelay: 500,
            popupCloseDelay: 0,
            appendToBody: true
        });
    });
})();
(function() {
	var CaptchaController = function($scope, $log, $state, ffDataFactory, contextualData, toaster, i18n, $sce) {
		var cc = this;
		cc.captchaEnabled = false;
		cc.apiKey = null;
		cc.saveCaptcha = saveCaptcha;
		cc.captchaUnavailableMessage = $sce.trustAsHtml(i18n.format('ff.label.captcha.unavailableMessage', "<a href='https://www.google.com/recaptcha' target='_blank'>Google reCaptcha</a>"));
		/**
		 * Remove key when toggle is switched off
		 */
		$scope.$watch(function() { return cc.captchaEnabled; }, function(a, b) {
			if (a !== b && !cc.captchaEnabled) {
				var request = {
					url: contextualData.context + '/modules/formfactory/settings/captchaapi/' + contextualData.siteIdentifier + '/en',
					method: 'DELETE'
				};
				if (cc.apiKey !== null && cc.apiKey.trim() !== '') {
					ffDataFactory.customRequest(request).then(function(success) {
						cc.apiKey = null;
						toaster.pop({
							type: 'success',
							title: i18n.message('ff.label.captcha.deleted')
						});
					}, function(error) {
						console.log(error);
					});
				}
			}
		});

		activate();

		function activate() {
			cc.apiKey = contextualData.captchaApiKey;
			if (cc.apiKey !== null && cc.apiKey !== '') {
				cc.captchaEnabled = true;
			}
		}

		function saveCaptcha() {
			var request = {
				url: contextualData.context + '/modules/formfactory/settings/captchaapi/' + contextualData.siteIdentifier + '/en',
				method: 'POST',
				data: cc.apiKey
			};
			ffDataFactory.customRequest(request).then(function(success) {
				toaster.pop({
					type: 'success',
					title: i18n.message('ff.label.captcha.saved')
				});
			}, function(error) {
				console.log(error);
			});
		}
	};

	CaptchaController.$inject = ['$scope', '$log', '$state', 'ffDataFactory', 'contextualData', 'toaster', 'i18nService', '$sce'];

	var captchaDirective = function($log, contextualData) {
		var directive = {
			restrict: 'E',
			templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/settings/captcha.html',
			controller: CaptchaController,
			controllerAs: 'cc',
			bindToController: true,
			link: linkFunction
		};

		return directive;

		function linkFunction(scope, el, attr) {
			//
		}
	};

	angular.module('formFactory')
		.directive('ffCaptcha', ['$log', 'contextualData', captchaDirective]);
})();(function() {
   var mainSettings = function(contextualData) {
       return {
           restrict: 'E',
           scope: {},
           templateUrl: contextualData.context + '/modules/form-factory-core/javascript/angular/components/settings/mainSettings.html',
           controller: MainSettingsController,
           controllerAs: 'msc',
           bindToController: true,
           link: linkFunc
       };

       function linkFunc(scope, el, attr, ctrl) {}
   };
    angular
        .module('formFactory')
        .directive('ffMainSettings', ['contextualData', mainSettings]);

    MainSettingsController.$inject = ['contextualData', 'ffDataFactory', 'toaster', 'i18nService'];

    function MainSettingsController (contextualData, ffDataFactory, toaster, i18n) {
        var msc = this;
        msc.clearDefinitionsCache = clearDefinitionsCache;

        function clearDefinitionsCache() {
            var request = {
                url : contextualData.context + '/modules/formfactory/settings/flush/',
                method: 'POST'
            };
            ffDataFactory.customRequest(request).then(function(){
                toaster.pop({
                    type: 'success',
                    title: i18n.message('angular.ffMainSettingsDirective.title.flushSuccessful'),
                    toastId: 'mscfs',
                    timeout: 3000
                })
            }, function() {
                toaster.pop({
                    type: 'error',
                    title: i18n.message('angular.ffMainSettingsDirective.title.flushFailed'),
                    toastId: 'mscff',
                    timeout: 3000
                })
            })
        }
    }

})();angular.module('formFactory').config(function(contextualData, $stateProvider, $urlRouterProvider) {
	$urlRouterProvider.otherwise(function ($injector, $location) {
		var $state = $injector.get('$state');
		if ($location.$$state == null) {
			$state.go('management', {}, {
				location: false
			});
		}
	});

	$stateProvider
		.state('management', {
			url: '/management',
			templateUrl:contextualData.urlBaseSiteSettingsTemplates + 'management.html.ajax'
		})
}, ['contextualData', '$stateProvider', '$urlRouterProvider']);