onmessage = function(e) {
    'use strict';

    var layoutInvalid = false;
    var messages = [];
    if (e.data.layout !== null && e.data.layout.active && e.data.layout.steps.length > 0) {
        var runningInputCount = 0;
        for (var i in e.data.layout.steps[e.data.currentStep].rows) {
            for (var j in e.data.layout.steps[e.data.currentStep].rows[i].row) {
                //check each column if there is an input assigned.)
                if (e.data.layout.steps[e.data.currentStep].rows[i].row[j].layoutUUID !== undefined &&
                    e.data.layout.steps[e.data.currentStep].rows[i].row[j].layoutUUID !== null &&
                    e.data.layout.steps[e.data.currentStep].rows[i].row[j].layoutUUID.trim() !== '') {
                    runningInputCount++;
                }
            }
        }

        //If not all inputs have been added to the current step's layout, then notify user
        //with a warning.
        if (runningInputCount !== e.data.steps[e.data.currentStep].inputs.length) {
            messages.unassignedElement = {};
            messages.unassignedElement.validationMessage = 'angular.ffFormBuilderDirective.message.unassignedElement';
            messages.unassignedElement.errorInfo = '';
            messages.unassignedElement.toastId = 'ue';
            messages.unassignedElement.class = 'warning';
        }
        for (var i = e.data.layout.steps.length-1; i >= 0; i--) {
            var containsAnInput = false;
            for (var j in e.data.layout.steps[i].rows) {
                for (var k in e.data.layout.steps[i].rows[j].row) {
                    if (e.data.layout.steps[i].rows[j].row[k].layoutUUID !== undefined &&
                        e.data.layout.steps[i].rows[j].row[k].layoutUUID !== null &&
                        e.data.layout.steps[i].rows[j].row[k].layoutUUID.trim() !== '') {
                        containsAnInput = true;
                        break;
                    }
                }
                if (containsAnInput) {
                    break;
                }
            }
            if (containsAnInput) {
                containsAnInput = false;
            } else {
                //If step contains no input, flag layoutInvalid error
                messages.layoutStepInvalid = {};
                messages.layoutStepInvalid.validationMessage = 'angular.ffFormBuilderDirective.message.layoutStepInvalid';
                messages.layoutStepInvalid.errorInfo = e.data.steps[i].label !== "" ? "'" + e.data.steps[i].label + "'" : "'name is empty'";
                messages.layoutStepInvalid.stepIndex = i;
                messages.layoutStepInvalid.toastId = 'lsi';
                messages.layoutStepInvalid.class = 'error';
                layoutInvalid = true;
                break;
            }
        }
    }
    postMessage({
        flag: 'stepContainsUnassignedElements',
        flagValue: layoutInvalid,
        callbacks: [
            {
                callback: 'unassignedElementsNotification',
                args: messages
            }
        ]
    });
    //Remove thread!!!
    close();
};